<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblCiudadRepository;

final class TblCiudadService
{
    private TblCiudadRepository $TblCiudadRepository;

    public function __construct(TblCiudadRepository $TblCiudadRepository)
    {
        $this->TblCiudadRepository = $TblCiudadRepository;
    }

    public function checkAndGet(int $TblCiudadId): object
    {
        return $this->TblCiudadRepository->checkAndGet($TblCiudadId);
    }

    public function getAll(): array
    {
        return $this->TblCiudadRepository->getAll();
    }

    public function getOne(int $TblCiudadId): object
    {
        return $this->checkAndGet($TblCiudadId);
    }

    public function create(array $input): object
    {
        $TblCiudad = json_decode((string) json_encode($input), false);

        return $this->TblCiudadRepository->create($TblCiudad);
    }

    public function update(array $input, int $TblCiudadId): object
    {
        $TblCiudad = $this->checkAndGet($TblCiudadId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblCiudadRepository->update($TblCiudad, $data);
    }

    public function delete(int $TblCiudadId): void
    {
        $this->checkAndGet($TblCiudadId);
        $this->TblCiudadRepository->delete($TblCiudadId);
    }
}
